Index: kernel/generic/src/ddi/ddi.c
===================================================================
--- kernel/generic/src/ddi/ddi.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/generic/src/ddi/ddi.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -107,4 +107,15 @@
 }
 
+/** Norify physical area has been unmapped.
+ *
+ * @param parea Physical area
+ */
+void ddi_parea_unmap_notify(parea_t *parea)
+{
+	parea->mapped = false;
+	if (parea->mapped_changed != NULL)
+		parea->mapped_changed(parea->arg);
+}
+
 /** Map piece of physical memory into virtual address space of current task.
  *
@@ -204,4 +215,6 @@
 
 map:
+	backend_data.parea = parea;
+
 	if (!as_area_create(TASK->as, flags, FRAMES2SIZE(pages),
 	    AS_AREA_ATTR_NONE, &phys_backend, &backend_data, virt, bound)) {
@@ -443,4 +456,5 @@
 	backend_data.frames = frames;
 	backend_data.anonymous = true;
+	backend_data.parea = NULL;
 
 	if (!as_area_create(TASK->as, map_flags, size,
Index: kernel/generic/src/lib/halt.c
===================================================================
--- kernel/generic/src/lib/halt.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/generic/src/lib/halt.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -36,4 +36,5 @@
  */
 
+#include <stdbool.h>
 #include <halt.h>
 #include <log.h>
@@ -44,5 +45,5 @@
 
 /** Halt flag */
-atomic_t haltstate = 0;
+atomic_bool haltstate = false;
 
 /** Halt wrapper
@@ -57,9 +58,9 @@
 
 	if (!atomic_load(&haltstate)) {
-		atomic_store(&haltstate, 1);
+		atomic_store(&haltstate, true);
 		rundebugger = true;
 	}
 #else
-	atomic_store(&haltstate, 1);
+	atomic_store(&haltstate, true);
 #endif
 
Index: kernel/generic/src/mm/backend_phys.c
===================================================================
--- kernel/generic/src/mm/backend_phys.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/generic/src/mm/backend_phys.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -38,4 +38,5 @@
 
 #include <assert.h>
+#include <ddi/ddi.h>
 #include <typedefs.h>
 #include <mm/as.h>
@@ -101,8 +102,11 @@
 {
 	/*
-	 * Nothing to do.
 	 * The anonymous frames, if any, are released in
 	 * phys_destroy_shared_data().
 	 */
+
+	/* Notify parea has been unmapped */
+	if (area->backend_data.parea != NULL)
+		ddi_parea_unmap_notify(area->backend_data.parea);
 }
 
Index: kernel/generic/src/mm/frame.c
===================================================================
--- kernel/generic/src/mm/frame.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/generic/src/mm/frame.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -85,7 +85,7 @@
 }
 
-/*******************/
-/* Zones functions */
-/*******************/
+/*
+ * Zones functions
+ */
 
 /** Insert-sort zone into zones list.
@@ -341,7 +341,7 @@
 }
 
-/******************/
-/* Zone functions */
-/******************/
+/*
+ * Zone functions
+ */
 
 /** Return frame from zone. */
@@ -781,7 +781,7 @@
 }
 
-/*******************/
-/* Frame functions */
-/*******************/
+/*
+ * Frame functions
+ */
 
 /** Set parent of frame. */
Index: kernel/generic/src/mm/slab.c
===================================================================
--- kernel/generic/src/mm/slab.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/generic/src/mm/slab.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -151,7 +151,7 @@
 #endif
 
-/**************************************/
-/* Slab allocation functions          */
-/**************************************/
+/*
+ * Slab allocation functions
+ */
 
 /** Allocate frames for slab space and initialize
@@ -223,7 +223,7 @@
 }
 
-/******************/
-/* Slab functions */
-/******************/
+/*
+ * Slab functions
+ */
 
 /** Return object to slab and call a destructor
@@ -323,7 +323,7 @@
 }
 
-/****************************/
-/* CPU-Cache slab functions */
-/****************************/
+/*
+ * CPU-Cache slab functions
+ */
 
 /** Find a full magazine in cache, take it from list and return it
@@ -531,7 +531,7 @@
 }
 
-/************************/
-/* Slab cache functions */
-/************************/
+/*
+ * Slab cache functions
+ */
 
 /** Return number of objects that fit in certain cache size
Index: kernel/generic/src/proc/scheduler.c
===================================================================
--- kernel/generic/src/proc/scheduler.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/generic/src/proc/scheduler.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -68,5 +68,5 @@
 static void scheduler_separated_stack(void);
 
-atomic_t nrdy;  /**< Number of ready threads in the system. */
+atomic_size_t nrdy;  /**< Number of ready threads in the system. */
 
 /** Carry out actions before new task runs. */
Index: kernel/test/atomic/atomic1.c
===================================================================
--- kernel/test/atomic/atomic1.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/test/atomic/atomic1.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -32,5 +32,5 @@
 const char *test_atomic1(void)
 {
-	atomic_t a;
+	atomic_int a;
 
 	atomic_store(&a, 10);
Index: kernel/test/mm/falloc2.c
===================================================================
--- kernel/test/mm/falloc2.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/test/mm/falloc2.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -43,6 +43,6 @@
 #define THREADS      8
 
-static atomic_t thread_cnt;
-static atomic_t thread_fail;
+static atomic_size_t thread_cnt;
+static atomic_size_t thread_fail;
 
 static void falloc(void *arg)
Index: kernel/test/synch/semaphore1.c
===================================================================
--- kernel/test/synch/semaphore1.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/test/synch/semaphore1.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -41,6 +41,6 @@
 
 static waitq_t can_start;
-static atomic_t items_produced;
-static atomic_t items_consumed;
+static atomic_size_t items_produced;
+static atomic_size_t items_consumed;
 
 static void producer(void *arg)
Index: kernel/test/thread/thread1.c
===================================================================
--- kernel/test/thread/thread1.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ kernel/test/thread/thread1.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -30,4 +30,5 @@
 #include <test.h>
 #include <atomic.h>
+#include <stdbool.h>
 #include <proc/thread.h>
 
@@ -36,6 +37,6 @@
 #define THREADS  5
 
-static atomic_t finish;
-static atomic_t threads_finished;
+static atomic_bool finish;
+static atomic_size_t threads_finished;
 
 static void threadtest(void *data)
@@ -55,5 +56,5 @@
 	size_t total = 0;
 
-	atomic_store(&finish, 1);
+	atomic_store(&finish, true);
 	atomic_store(&threads_finished, 0);
 
@@ -72,5 +73,5 @@
 	thread_sleep(10);
 
-	atomic_store(&finish, 0);
+	atomic_store(&finish, false);
 	while (atomic_load(&threads_finished) < total) {
 		TPRINTF("Threads left: %zu\n", total - atomic_load(&threads_finished));
Index: meson.build
===================================================================
--- meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -35,5 +35,5 @@
     'HelenOS',
     [ 'c', 'cpp' ],
-    default_options : ['buildtype=plain', 'c_std=gnu11', 'cpp_std=c++17', 'warning_level=3', 'werror=false', 'b_staticpic=false', 'prefix=/' ],
+    default_options : ['buildtype=plain', 'c_std=gnu11', 'cpp_std=c++17', 'warning_level=2', 'werror=false', 'b_staticpic=false', 'prefix=/' ],
     meson_version: '>=0.50.1',
 )
Index: tools/build-ccheck.sh
===================================================================
--- tools/build-ccheck.sh	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ tools/build-ccheck.sh	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -29,5 +29,5 @@
 
 SYCEK_GIT="https://github.com/jxsvoboda/sycek"
-SYCEK_REV="4dc1760741efdd84506478ab6effd68812b4726a"
+SYCEK_REV="14f0aadad8bb2f17eef030a74b3591377ad57343"
 
 if [ ! -d sycek ]; then
Index: tools/ew.py
===================================================================
--- tools/ew.py	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ tools/ew.py	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -139,5 +139,8 @@
 		return 'system-x86_64', pc_options(64)
 	elif platform == 'arm32':
-		return 'system-arm', '-M integratorcp'
+		if machine == 'integratorcp':
+			return 'system-arm', '-M integratorcp'
+		elif machine == 'raspberrypi':
+			return 'system-arm', '-M raspi1ap'
 	elif platform == 'arm64':
 		# Search for the EDK2 firmware image
@@ -299,4 +302,6 @@
 	elif cfg['image'] == 'image.boot':
 		cmdline += ' -kernel image.boot'
+	elif cfg['image'] == 'kernel.img@rpi':
+		cmdline += ' -bios boot/image.boot.bin'
 	else:
 		cmdline += ' ' + cfg['image']
@@ -339,5 +344,16 @@
 			'xhci' : False,
 			'tablet' : False
-		}
+		},
+		'raspberrypi' : {
+			'run' : qemu_run,
+			'image' : 'kernel.img@rpi',
+			'audio' : False,
+			'console' : True,
+			'hdd' : False,
+			'net' : False,
+			'tablet' : False,
+			'usb' : False,
+			'xhci' : False
+		},
 	},
 	'arm64' : {
Index: tools/export.sh
===================================================================
--- tools/export.sh	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ tools/export.sh	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -42,4 +42,5 @@
 	uspace/lib/libclui.a \
 	uspace/lib/libc.a \
+	uspace/lib/libcongfx.a \
 	uspace/lib/libcpp.a \
 	uspace/lib/libdisplay.a \
Index: tools/mkfat.py
===================================================================
--- tools/mkfat.py	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ tools/mkfat.py	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,3 +1,3 @@
-#!/usr/bin/env python
+#!/usr/bin/env python3
 #
 # Copyright (c) 2008 Martin Decky
@@ -193,6 +193,6 @@
 
 	for char in name.encode('ascii', 'replace').upper():
-		if char in lchars:
-			filtered_name += char
+		if chr(char) in lchars:
+			filtered_name += str.encode(chr(char))
 		else:
 			filtered_name += b'_'
Index: tools/toolchain.sh
===================================================================
--- tools/toolchain.sh	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ tools/toolchain.sh	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -41,7 +41,8 @@
 GCC_VERSION="8.2.0"
 
-BASEDIR="`pwd`"
+BASEDIR="$PWD"
 SRCDIR="$(readlink -f $(dirname "$0"))"
 
+SYSTEM_INSTALL=false
 REAL_INSTALL=true
 USE_HELENOS_TARGET=true
@@ -57,9 +58,9 @@
 
 show_usage() {
-	echo "Cross-compiler toolchain build script"
+	echo "HelenOS cross-compiler toolchain build script"
 	echo
 	echo "Syntax:"
-	echo " $0 [--no-install] [--non-helenos-target] <platform>"
-	echo " $0 --test-version [<platform>]"
+	echo " $0 [--system-wide] [--no-install] [--non-helenos-target] <platform>"
+	echo " $0 [--system-wide] --test-version [<platform>]"
 	echo
 	echo "Possible target platforms are:"
@@ -79,28 +80,55 @@
 	echo " 2-way      same as 'all', but 2-way parallel"
 	echo
-	echo "The toolchain is installed into directory specified by the"
-	echo "CROSS_PREFIX environment variable. If the variable is not"
-	echo "defined, /usr/local/cross/ is used as default."
-	echo
-	echo "If --no-install is present, the toolchain still uses the"
-	echo "CROSS_PREFIX as the target directory but the installation"
-	echo "copies the files into PKG/ subdirectory without affecting"
-	echo "the actual root file system. That is only useful if you do"
-	echo "not want to run the script under the super user."
-	echo
-	echo "The --non-helenos-target will build non-HelenOS-specific toolchain"
-	echo "(i.e. it will use *-linux-* triplet instead of *-helenos)."
+	echo "The toolchain target installation directory is determined by matching"
+	echo "the first of the following conditions:"
+	echo
+	echo " (1) If the \$CROSS_PREFIX environment variable is set, then it is"
+	echo "     used as the target installation directory."
+	echo " (2) If the --system-wide option is used, then /opt/HelenOS/cross"
+	echo "     is used as the target installation directory. This usually"
+	echo "     requires running this script with super user privileges."
+	echo " (3) In other cases, \$XDG_DATA_HOME/HelenOS/cross is used as the"
+	echo "     target installation directory. If the \$XDG_DATA_HOME environment"
+	echo "     variable is not set, then the default value of \$HOME/.local/share"
+	echo "     is assumed."
+	echo
+	echo "If the --no-install option is used, the toolchain still uses the"
+	echo "target installation directory as determined above, but the files"
+	echo "are actually copied into the PKG/ subdirectory during the installation"
+	echo "without affecting the actual target file system. This might be useful"
+	echo "when preparing a system-wide installation, but avoiding running this"
+	echo "script under the super user."
+	echo
+	echo "The --non-helenos-target option will build non-HelenOS-specific"
+	echo "toolchain (i.e. it will use *-linux-* triplet instead of *-helenos)."
 	echo "Using this toolchain for building HelenOS is not supported."
 	echo
+	echo "The --test-version mode tests the currently installed version of the"
+	echo "toolchain."
 
 	exit 3
 }
 
+set_cross_prefix() {
+	if [ -z "$CROSS_PREFIX" ] ; then
+		if $SYSTEM_INSTALL ; then
+			CROSS_PREFIX="/opt/HelenOS/cross"
+		else
+			if [ -z "$XDG_DATA_HOME" ] ; then
+				XDG_DATA_HOME="$HOME/.local/share"
+			fi
+			CROSS_PREFIX="$XDG_DATA_HOME/HelenOS/cross"
+		fi
+	fi
+}
+
 test_version() {
-	echo "Cross-compiler toolchain build script"
-	echo
-	echo "Start testing the version of the installed software" 
-	echo
-	
+	set_cross_prefix
+
+	echo "HelenOS cross-compiler toolchain build script"
+	echo
+	echo "Testing the version of the installed software in $CROSS_PREFIX"
+	echo
+
 	if [ -z "$1" ] || [ "$1" = "all" ] ; then
 		PLATFORMS='amd64 arm32 arm64 ia32 ia64 mips32 mips32eb ppc32 riscv64 sparc64'
@@ -108,13 +136,6 @@
 		PLATFORMS="$1"
 	fi
-	
-	
-	if [ -z "${CROSS_PREFIX}" ] ; then
-		CROSS_PREFIX="/usr/local/cross"
-	fi
-
-	for i in $PLATFORMS
-	do
-		PLATFORM="$i"
+
+	for PLATFORM in $PLATFORMS ; do
 		set_target_from_platform "$PLATFORM"
 		PREFIX="${CROSS_PREFIX}/bin/${HELENOS_TARGET}"
@@ -125,6 +146,4 @@
 		test_app_version "GDB" "gdb" "GNU gdb (.*)[[:space:]]\+\([.0-9]*\)" "$GDB_VERSION"
 	done
-
-	exit
 }
 
@@ -135,5 +154,4 @@
 	INS_VERSION="$4"
 
-
 	APP="${PREFIX}-${APPNAME}"
 	if [ ! -e $APP ]; then
@@ -148,5 +166,5 @@
 
 		if [ "$INS_VERSION" = "$VERSION" ]; then
-			echo "+ $PKGNAME is uptodate ($INS_VERSION)"
+			echo "+ $PKGNAME is up-to-date ($INS_VERSION)"
 		else
 			echo "- $PKGNAME ($VERSION) is outdated ($INS_VERSION)"
@@ -155,6 +173,4 @@
 }
 
-
-
 change_title() {
 	printf "\e]0;$1\a"
@@ -178,4 +194,11 @@
 
 show_dependencies() {
+	set_cross_prefix
+
+	echo "HelenOS cross-compiler toolchain build script"
+	echo
+	echo "Installing software to $CROSS_PREFIX"
+	echo
+	echo
 	echo "IMPORTANT NOTICE:"
 	echo
@@ -255,4 +278,5 @@
 	check_error $? "Change directory failed."
 
+	change_title "Downloading sources"
 	echo ">>> Downloading sources"
 	git clone --depth 1 -b "$BINUTILS_BRANCH" "$BINUTILS_GDB_GIT" "binutils-$BINUTILS_VERSION"
@@ -265,4 +289,5 @@
 	git -C "gcc-$GCC_VERSION" pull
 
+	change_title "Downloading GCC prerequisites"
 	echo ">>> Downloading GCC prerequisites"
 	cd "gcc-${GCC_VERSION}"
@@ -325,10 +350,9 @@
 	GDBDIR="${WORKDIR}/gdb-${GDB_VERSION}"
 
-	if [ -z "${CROSS_PREFIX}" ] ; then
-		CROSS_PREFIX="/usr/local/cross"
-	fi
+	# This sets the CROSS_PREFIX variable
+	set_cross_prefix
 
 	if [ -z "$JOBS" ] ; then
-		JOBS=`nproc`
+		JOBS="`nproc`"
 	fi
 
@@ -341,4 +365,5 @@
 
 	if $USE_HELENOS_TARGET ; then
+		change_title "Creating build sysroot"
 		echo ">>> Creating build sysroot"
 		mkdir -p "${WORKDIR}/sysroot/include"
@@ -355,4 +380,5 @@
 		check_error $? "Failed to create build sysroot."
 	fi
+
 
 	echo ">>> Processing binutils (${PLATFORM})"
@@ -416,9 +442,9 @@
 		PATH="${PATH}:${PREFIX}/bin:${INSTALL_DIR}/${PREFIX}/bin" make all-target-libgcc -j$JOBS
 		check_error $? "Error compiling libgcc."
-		# TODO: needs some extra care
-		#PATH="${PATH}:${PREFIX}/bin:${INSTALL_DIR}/${PREFIX}/bin" make all-target-libatomic -j$JOBS
-		#check_error $? "Error compiling libatomic."
-		#PATH="${PATH}:${PREFIX}/bin:${INSTALL_DIR}/${PREFIX}/bin" make all-target-libstdc++-v3 -j$JOBS
-		#check_error $? "Error compiling libstdc++."
+		# TODO: libatomic and libstdc++ need some extra care
+		#    PATH="${PATH}:${PREFIX}/bin:${INSTALL_DIR}/${PREFIX}/bin" make all-target-libatomic -j$JOBS
+		#    check_error $? "Error compiling libatomic."
+		#    PATH="${PATH}:${PREFIX}/bin:${INSTALL_DIR}/${PREFIX}/bin" make all-target-libstdc++-v3 -j$JOBS
+		#    check_error $? "Error compiling libstdc++."
 	fi
 
@@ -427,6 +453,6 @@
 	if $USE_HELENOS_TARGET ; then
 		PATH="${PATH}:${INSTALL_DIR}/${PREFIX}/bin" make install-target-libgcc "DESTDIR=${INSTALL_DIR}"
-		#PATH="${PATH}:${INSTALL_DIR}/${PREFIX}/bin" make install-target-libatomic "DESTDIR=${INSTALL_DIR}"
-		#PATH="${PATH}:${INSTALL_DIR}/${PREFIX}/bin" make install-target-libstdc++-v3 "DESTDIR=${INSTALL_DIR}"
+		#    PATH="${PATH}:${INSTALL_DIR}/${PREFIX}/bin" make install-target-libatomic "DESTDIR=${INSTALL_DIR}"
+		#    PATH="${PATH}:${INSTALL_DIR}/${PREFIX}/bin" make install-target-libstdc++-v3 "DESTDIR=${INSTALL_DIR}"
 	fi
 	check_error $? "Error installing GCC."
@@ -463,5 +489,4 @@
 	if $REAL_INSTALL ; then
 		echo ">>> Moving to the destination directory."
-		echo cp -r -t "${PREFIX}" "${INSTALL_DIR}/${PREFIX}/"*
 		cp -r -t "${PREFIX}" "${INSTALL_DIR}/${PREFIX}/"*
 	fi
@@ -479,4 +504,8 @@
 while [ "$#" -gt 1 ] ; do
 	case "$1" in
+		--system-wide)
+			SYSTEM_INSTALL=true
+			shift
+			;;
 		--test-version)
 			test_version "$2"
@@ -504,4 +533,5 @@
 	--test-version)
 		test_version
+		exit
 		;;
 	amd64|arm32|arm64|ia32|ia64|mips32|mips32eb|ppc32|riscv64|sparc64)
Index: tools/xcw/bin/helenos-pkg-config
===================================================================
--- tools/xcw/bin/helenos-pkg-config	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ tools/xcw/bin/helenos-pkg-config	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -44,6 +44,6 @@
 libmath_libs="$LIB_DIR/libmath.a"
 
-libui_cflags="-I$INCLUDE_DIR/libui -I$INCLUDE_DIR/libdisplay -I$INCLUDE_DIR/libgfx -I$INCLUDE_DIR/libipcgfx"
-libui_libs="$LIB_DIR/libui.a $LIB_DIR/libdisplay.a $LIB_DIR/libipcgfx.a $LIB_DIR/libgfx.a $LIB_DIR/libgfxfont.a $LIB_DIR/libriff.a $LIB_DIR/libmemgfx.a"
+libui_cflags="-I$INCLUDE_DIR/libui -I$INCLUDE_DIR/libdisplay -I$INCLUDE_DIR/libgfx -I$INCLUDE_DIR/libipcgfx -I$INCLUDE_DIR/libcongfx"
+libui_libs="$LIB_DIR/libui.a $LIB_DIR/libdisplay.a $LIB_DIR/libipcgfx.a $LIB_DIR/libcongfx.a $LIB_DIR/libgfx.a $LIB_DIR/libgfxfont.a $LIB_DIR/libriff.a $LIB_DIR/libmemgfx.a"
 
 libgfximage_cflags="-I$INCLUDE_DIR/libgfximage"
Index: tools/xcw/demo/Makefile
===================================================================
--- tools/xcw/demo/Makefile	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ tools/xcw/demo/Makefile	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -50,7 +50,7 @@
 INSTALL = install
 TEST = helenos-test
-CFLAGS = -std=gnu11 -Wall `helenos-pkg-config --cflags libui libdraw libmath` \
+CFLAGS = -std=gnu11 -Wall `helenos-pkg-config --cflags libui libgfximage` \
     -D_HELENOS_SOURCE
-LIBS = `helenos-pkg-config --libs libui libdraw libmath`
+LIBS = `helenos-pkg-config --libs libui libgfximage`
 PREFIX = `helenos-bld-config --install-dir`
 output = viewer
Index: uspace/app/barber/meson.build
===================================================================
--- uspace/app/barber/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/barber/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -27,5 +27,5 @@
 #
 
-deps = [ 'ui', 'gfximage', 'compress' ]
+deps = [ 'ui', 'gfximage', 'compress', 'device' ]
 
 _images = files(
Index: uspace/app/bdsh/cmds/modules/cat/cat.c
===================================================================
--- uspace/app/bdsh/cmds/modules/cat/cat.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/bdsh/cmds/modules/cat/cat.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -122,9 +122,10 @@
 	cons_event_t ev;
 	kbd_event_t *kev;
+	errno_t rc;
 
 	while (true) {
-		if (!console_get_event(console, &ev)) {
+		rc = console_get_event(console, &ev);
+		if (rc != EOK)
 			return;
-		}
 		if (ev.type == CEV_KEY && ev.ev.key.type == KEY_PRESS) {
 			kev = &ev.ev.key;
Index: uspace/app/bdsh/cmds/modules/cp/cp.c
===================================================================
--- uspace/app/bdsh/cmds/modules/cp/cp.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/bdsh/cmds/modules/cp/cp.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -146,4 +146,5 @@
 {
 	va_list args;
+	errno_t rc;
 
 	va_start(args, message);
@@ -154,5 +155,7 @@
 		cons_event_t ev;
 		console_flush(con);
-		console_get_event(con, &ev);
+		rc = console_get_event(con, &ev);
+		if (rc != EOK)
+			exit(1);
 		if (ev.type != CEV_KEY || ev.ev.key.type != KEY_PRESS ||
 		    (ev.ev.key.mods & (KM_CTRL | KM_ALT)) != 0) {
